#ifndef _UNIXSerialPort_h_INCLUDED_
#define _UNIXSerialPort_h_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

/*****************************************************************************/
/* 饹                                                              */
/*****************************************************************************/

typedef struct _UNIXSerialPort * UNIXSerialPort;

/*****************************************************************************/
/* إåեΥ󥯥롼                                              */
/*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

/*****************************************************************************/
/* дؿ                                                          */
/*****************************************************************************/

/*---------------------------------------------------------------------------*/
/* ݡȤ open/close                                                       */
/*---------------------------------------------------------------------------*/

int UNIXSerialPort_Open(UNIXSerialPort unix_serial_port);
int UNIXSerialPort_Close(UNIXSerialPort unix_serial_port);

int UNIXSerialPort_IsOpened(UNIXSerialPort unix_serial_port);
int UNIXSerialPort_IsClosed(UNIXSerialPort unix_serial_port);

/*---------------------------------------------------------------------------*/
/* ǡ뤫ɤ                                                  */
/*---------------------------------------------------------------------------*/

/*
 * ॢȻ֤ߥñ̤ǻꡥ
 * 0 ΤȤϡ¨
 * -1 ΤȤϡ̵Ԥ
 */

int UNIXSerialPort_IsDataExisting(UNIXSerialPort unix_serial_port,
				  int timeout);

/*---------------------------------------------------------------------------*/
/*                                                                       */
/*---------------------------------------------------------------------------*/

int UNIXSerialPort_ReceiveCharacter(UNIXSerialPort unix_serial_port,
				    int timeout);

/*---------------------------------------------------------------------------*/
/*                                                                       */
/*---------------------------------------------------------------------------*/

int UNIXSerialPort_SendCharacter(UNIXSerialPort unix_serial_port,
				 unsigned char c);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

UNIXSerialPort UNIXSerialPort_Create();

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

UNIXSerialPort UNIXSerialPort_Destroy(UNIXSerialPort unix_serial_port);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
